package formFaces.action;

import java.util.Enumeration;
import java.util.Iterator;
import java.util.List;

import formFaces.excepcio.FormFacesExcepcio;

public abstract class JspForm extends Classe{

	public void map(ActionForm form) {
		for (Enumeration<String> par = super.getClauParametres(); par.hasMoreElements();){
			String param = par.nextElement();
			String valor = form.getValor(param);
			if (valor == null){
				form.novaExcepcio(new FormFacesExcepcio("Parametre del JspForm "+param+" no existeix al ActionForm", 5));
			} else {
				super.setValor(param, valor);
			}
		}
		for (Enumeration<String> cla = super.getClauClasses(); cla.hasMoreElements();){
			String param = cla.nextElement();
			Classe valor = form.getClasse(param);
			if (valor == null){
				form.novaExcepcio(new FormFacesExcepcio("Llista del JspForm "+param+" no existeix al ActionForm", 5));
			} else {
				Classe actual = getClasse(param);
				actual.clone(valor);
			}
		}
		for (Enumeration<String> lli = super.getClauLlistes(); lli.hasMoreElements();){
			String param = lli.nextElement();
			List<Classe> valor = form.getLlista(param);
			if (valor == null){
				form.novaExcepcio(new FormFacesExcepcio("Llista del JspForm "+param+" no existeix al ActionForm", 5));
			} else {
				List<Classe> actual = this.getLlista(param);
				actual.clear();
				for (Iterator<Classe> it=valor.iterator(); it.hasNext();){
					actual.add(it.next());
				}
			}
		}
		excepcions = form.getExcepcions();
	}
		
	@Override
	protected abstract void definicio();

}
