package formFaces.action;

import java.util.Iterator;

import formFaces.excepcio.*;

public class ProvaForm extends ActionForm {

	@Override
	/**
	 * Definici del formulari
	 * 		addParametre(String, String) crea els parmetres. 
	 * 									El primer String es el nom i el segon es el tipus de parametre que pot ser:
	 * 									-	String
	 * 									- 	Integer
	 * 									-	Float
	 * 									-	Long
	 * 									-	Double
	 * 									-	Date
	 * 									-	Byte
	 * 									-	Short
	 * 									-	Boolean
	 * 		addValidacio(String) crea una validaci per l'ultim parmetre. String es la comparaci que pot ser:
	 * 									-	le	menor o igual
	 * 									-	lt	menor
	 * 									-	ge	major o igual
	 * 									-	gt	major
	 * 									-	eq	igual
	 * 									-	ne	diferent
	 * 									-	bt	entre dos valors inclosos
	 * 									-	nb	fora de dos valors
	 * 									-	in	est en una llista de valors
	 * 									-	ni	no est en una llista de valors
	 * 		addValor(Comparable) afegeix un valor a comparar a la ltima validaci
	 * 		addValidacio(String, Comparable) crea una validaci i li afegeix un valor a comparar
	 * 		addValidacio(String, Comparable, Comparable) crea una validaci i li afegeix dos valors a comparar
	 * 		addClasse(String, String) crea les classes que porten les dades del formulari
	 * 									el primer String es el nom de la classe
	 * 									el segon String es el tipus de classe
	 * 		addList(String, String) crea les llistes de classes que portaran els valors
	 * 									el primer String es el nom de la llista
	 * 									el segon String es el tipus de classe
	 * 									 
	 */
	protected void definicio() {
		addParametre("sencer", "Integer");
		addValidacio("lt", 4);
		addParametre("text", "String");
		addValidacio("in", "UN", "DOS");
		addValor("TRES");
		addClasse("formulari","ProvaClasse");
		addList("formularis","ProvaClasse");
	}

	/**
	 * 		addJsp(String) crea un nou JspResolver per resodre aquest Jsp
	 * 		addJspStatus(String, String) crea un nou Status i l'afegeix al JspResolver. El primer String es el tipus d'estat.
	 * 										Els tipus dpestat possibles son:		
	 * 												. "llista", nomLlista				Ok si la llista te elements
	 * 												- "parametre", nomParametre			Ok si el parametre compleis una validacio
	 * 												- "classe", nomClasse.nomParametre  Ok si el parametre de la classe compliex ina validacio.	
	 * 		addValidacioStatus(String) crea una validaci per l'ultim Status. String es la comparaci que est definida a vaidacio
	 * 		addValorStatus(Comparable) afegeix un valor a comparar a l'ltima validaci
	 * 		addValidacioStatus(String, Comparable) crea una validacio per l'ultim status i li afegeix un valor a comparar
	 * 		addValidacioStatus(String, Comparable, Comparable) crea una validacio per l'ultim status i li afegeix dos valors a comparar
	 * 
	 */
	protected void definicioResolucioJsp() {
		addJsp("jsp1");
		addJspStatus("llista", "formularis");
		addJsp("jsp2");
		addJspStatus("parametre", "text");
		addValidacioStatus("eq", "DOS");
		addJspStatus("campClasse", "formulari.flotant");
		addValidacioStatus("bt", "3", "5");
		addJsp("jsp3");
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ProvaForm f = new ProvaForm();
		f.setValor("sencer", "3");
		f.setValor("text", "DOS");
		f.getClasse("formulari").setValor("flotant", "5.25");
		f.getLlista("formularis").add(new ProvaClasse());
		Excepcions errors = f.getExcepcions();
		for (Iterator<FormFacesExcepcio> it=errors.getItExcepcions(1); it.hasNext();){
			FormFacesExcepcio e = it.next();
			System.out.println(e.getGravetat()+" - "+e.getMessage());
		}
		System.out.println(f.getLlista("formularis").size());
		System.out.println(f.resolJsp());
	}

}
