package formFaces.action;

public class Status {
	private String llista;
	private String classe;
	private String parametre;
	private Validacio validacio;
	
	public Status(String tipus, String camp) {
		super();
		llista = null;
		classe = null;
		parametre = null;
		validacio = null;
		if (tipus.equalsIgnoreCase("llista")){
			llista = camp;
		}
		if (tipus.equalsIgnoreCase("campClasse")){
			int i = camp.indexOf(".");
			classe = camp.substring(0, i);
			parametre = camp.substring(i+1);
		}
		if (tipus.equalsIgnoreCase("parametre")){
			parametre = camp;
		}
	}

	public String getLlista() {
		return llista;
	}

	public void setLlista(String llista) {
		this.llista = llista;
	}

	public String getClasse() {
		return classe;
	}

	public void setClasse(String classe) {
		this.classe = classe;
	}

	public String getParametre() {
		return parametre;
	}

	public void setParametre(String parametre) {
		this.parametre = parametre;
	}

	public Validacio getValidacio() {
		return validacio;
	}

	public void setValidacio(Validacio validacio) {
		this.validacio = validacio;
	}	
	
	public boolean valida(ActionForm a){
		boolean estat = true;
		if (llista!=null){
			if (a.getLlista(llista)==null || a.getLlista(llista).isEmpty()){
				estat = false;
			}
		} else {
			if (classe!=null){
				if (a.getClasse(classe)==null || a.getClasse(classe).getValor(parametre)==null){
					estat = false;
				} else {
					if (validacio!=null && validacio.valida(a.getClasse(classe).getParametre(parametre))!=null){
						estat = false;
					}
				}
			} else {
				if (parametre == null){
					estat = false;
				} else {
					if (validacio!=null && validacio.valida(a.getValor(parametre))!=null){
						estat = false;
					}
				}
			}
		}
		return estat;
	}
	
	public String getTipusCamp(ActionForm a){
		String tipus = null;
		if (llista!=null){
			if (a.getLlista(llista)!=null){
				tipus = "Llista";
			}
		} else {
			if (classe!=null){ 
				if (a.getClasse(classe)!=null && a.getClasse(classe).getTipusParametre(parametre)!=null){
					tipus = a.getClasse(classe).getTipusParametre(parametre);
				}
			} else {
				if (parametre != null && a.getTipusParametre(parametre)!=null){
					tipus = a.getTipusParametre(parametre);
				}
			}
		}
		return tipus;
	}
}
