package formFaces.action;

import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;

import formFaces.excepcio.FormFacesExcepcio;

public class Validacio {
	private String comparacio;
	List<Comparable> valors;
	
	public Validacio() {
		super();
		comparacio = "";
		valors = new ArrayList<Comparable>();
	}

	public Validacio(String comparacio) {
		super();
		this.comparacio = comparacio;
		valors = new ArrayList<Comparable>();
	}

	public String getComparacio() {
		return comparacio;
	}

	public void setComparacio(String comparacio) {
		this.comparacio = comparacio;
	}

	public List<Comparable> getValors() {
		return valors;
	}

	public void setValors(List<Comparable> valors) {
		this.valors = valors;
	}
	
	public void addValor(Comparable valor) {
		this.valors.add(valor);
	}
	
	public FormFacesExcepcio valida(Comparable element){
		boolean correcte = false;
		String strValors = "T introduida una comparaci mal construida. Parlar amb el programador.";
		int gravetat = 5;
		if (comparacio.equalsIgnoreCase("lt") && valors.size() == 1){
			correcte = (element.compareTo(valors.get(0))<0);
			strValors = "Ha de ser menor que "+valors.get(0).toString();
			gravetat = 3;
		}
		if (comparacio.equalsIgnoreCase("le") && valors.size() == 1){
			correcte = (element.compareTo(valors.get(0))<=0);
			strValors = "Ha de ser menor o igual que "+valors.get(0).toString();
			gravetat = 3;
		}
		if (comparacio.equalsIgnoreCase("gt") && valors.size() == 1){
			correcte = (element.compareTo(valors.get(0))>0);
			strValors = "Ha de ser mes gran que "+valors.get(0).toString();
			gravetat = 3;
		}
		if (comparacio.equalsIgnoreCase("ge") && valors.size() == 1){
			correcte = (element.compareTo(valors.get(0))>=0);
			strValors = "Ha de ser mes gran o igual que "+valors.get(0).toString();
			gravetat = 3;
		}
		if (comparacio.equalsIgnoreCase("eq") && valors.size() == 1){
			correcte = (element.compareTo(valors.get(0))==0);
			strValors = "Ha de ser igual a "+valors.get(0).toString();
			gravetat = 3;
		}
		if (comparacio.equalsIgnoreCase("ne") && valors.size() == 1){
			correcte = (element.compareTo(valors.get(0))!=0);
			strValors = "Ha de ser diferent de "+valors.get(0).toString();
			gravetat = 3;
		}
		if (comparacio.equalsIgnoreCase("bt") && valors.size() == 2){
			correcte = (element.compareTo(valors.get(0))>=0)&&(element.compareTo(valors.get(1))<=0);
			strValors = "Ha d'estar entre "+valors.get(0).toString()+" i "+valors.get(1).toString();
			gravetat = 3;
		}
		if (comparacio.equalsIgnoreCase("nb") && valors.size() == 2){
			correcte = (element.compareTo(valors.get(0))<0)||(element.compareTo(valors.get(1))>0);
			strValors = "No ha d'estar entre "+valors.get(0).toString()+" i "+valors.get(1).toString();
			gravetat = 3;
		}
		if (comparacio.equalsIgnoreCase("ni")){
			strValors = "";
			gravetat = 3;
			boolean primer = true;
			for (Iterator<Comparable> it = valors.iterator();it.hasNext();){
				Comparable valor = it.next();
				if (primer){
					strValors = "No pot ser un dels valors: "+valor.toString();
					primer = false;
				} else {
					strValors = strValors + ", " + valor.toString();
				}
				if (element.compareTo(valor)==0){
					correcte = false;
				}
			}			
		}
		if (comparacio.equalsIgnoreCase("in") && valors.size() > 0){
			correcte = false;
			strValors = "";
			gravetat = 3;
			boolean primer = true;
			for (Iterator<Comparable> it = valors.iterator();it.hasNext();){
				Comparable valor = it.next();
				if (primer){
					strValors = "Ha de ser un dels valors: "+valor.toString();
					primer = false;
				} else {
					strValors = strValors + ", " + valor.toString();
				}
				if (element.compareTo(valor)==0){
					correcte = true;
				}
			}			
		}
		if (correcte){
			return null;
		} else {
			return new FormFacesExcepcio(strValors, gravetat);
		}
	}
	
}
