package formFaces.facade;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

public abstract class AbstractFilter implements Filter {
	private String nextPage;

	@Override
	public void destroy() {
	}

	@Override
	public void doFilter(ServletRequest rq, ServletResponse rp,
			FilterChain fch) throws IOException, ServletException {
		try {
			doPreProcessing(rq);
		} catch (IOException e) {
			throw e; 
		} catch (ServletException e) {
			throw e; 
		}
		doMainProcessing(rq, rp, (ChainFilter)fch);
		doPostProcessing(rq);

	}

	@Override
	public void init(FilterConfig fc) throws ServletException {
	}
	
	public abstract void doPreProcessing(ServletRequest request) throws IOException, ServletException;

	public abstract void doPostProcessing(ServletRequest request);

	public void doMainProcessing(ServletRequest request, ServletResponse response, ChainFilter chain){
		if (nextPage !=null){
			chain.setNextPage(nextPage);
		}
		try {
			chain.doFilter(request, response);
		} catch (Exception e){System.out.println("Error executant seguent doFilter. Fitre: "+this.getClass().getName());}
	}
	
	protected void setNetPage(String nextPage){
		this.nextPage = nextPage;
	}
	
	public String getNextPage(){
		return nextPage;
	}
}
