package formFaces.facade;

import java.io.IOException;
import java.util.Hashtable;

import javax.servlet.ServletException;
import javax.servlet.ServletRequest;

import formFaces.action.JspForm;

public class FacesFilter extends AbstractFilter {
	private Hashtable<String, JspForm > formularis;

	public FacesFilter(){
		formularis = new Hashtable<String, JspForm>();
	}
	
	@Override
	public void doPreProcessing(ServletRequest request) throws IOException,
			ServletException {
		String idForm = request.getParameter("idForm");
		String nom = "form_faces.jspForms."+idForm+"Form";
		super.setNetPage("/jsp/"+idForm+".jsp");
		if (nom !=null && formularis.containsKey(nom)){
			request.setAttribute("JspForm", formularis.get(nom));
		} else {
			request.setAttribute("JspForm", null);
		}
	}

	@Override
	public void doPostProcessing(ServletRequest request) {
		JspForm form = (JspForm)request.getAttribute("JspForm");
		if (form!=null){
			String nom = form.getClass().getName();
			formularis.put(nom, form);
		}
	}

}
