package formFaces.facade;

import java.util.*;

import formFaces.action.Action;
import formFaces.action.ActionForm;
import formFaces.action.JspForm;

public class Factory {
	static final String PACKAGE_ACT = "form_faces.actions";
	static final String PACKAGE_FRM = "form_faces.actionForms";
	static final String PACKAGE_JSP = "form_faces.jspForms";

	private static Factory f;
	Hashtable<String, Action > actions;
	Hashtable<String, ActionForm > forms;
	Hashtable<String, JspForm > jspForms;
	
	public Factory(){
		this.actions = new Hashtable<String, Action>();
		this.forms = new Hashtable<String, ActionForm>();
		this.jspForms = new Hashtable<String, JspForm>();
	}
	
	public static Factory getReference(){
		if(f==null) f = new Factory();
		return f;
	}

	public Action  getAction(String param) {
	  Action action = this.actions.get(param);
	  if (action==null) {
		  action = newAction(param);
		  this.actions.put(param, action);
	  }
	  return action;
	}

	private Action newAction(String param) {
		
		String nomClass= this.PACKAGE_ACT + "."+param;
		Class c;
		Action o = null;
		try{
			c = Class.forName(nomClass);
			o = (Action) c.newInstance();
		}
		catch(Exception e){
			e.printStackTrace();
		}
		return o;
	}

	public ActionForm  getActionForm(String param) {
	  ActionForm form = this.forms.get(param);
	  if (form==null) {
		  form = newForm(param);
		  this.forms.put(param, form);
	  } else {
		  form.clear();
	  }
	  return form;
	}

	private ActionForm newForm(String param) {
		
		String nomClass= this.PACKAGE_FRM + "."+param+"Form"; 
		Class c;
		ActionForm o = null;
		try{
			c = Class.forName(nomClass);
			o = (ActionForm) c.newInstance();
		}
		catch(Exception e){
			System.out.println("Error al cear el accioForm "+ param);
		}
		return o;
	}

	public JspForm  getJspForm(String param) {
	  JspForm form = this.jspForms.get(param);
	  if (form==null) {
		  form = newJspForm(param);
		  this.jspForms.put(param, form);
	  } else {
		  form.clear();
	  }
	  return form;
	}

	private JspForm newJspForm(String param) {
		
		String nomClass= this.PACKAGE_JSP + "."+param+"Form"; 
		Class c;
		JspForm o = null;
		try{
			c = Class.forName(nomClass);
			o = (JspForm) c.newInstance();
		}
		catch(Exception e){
			System.out.println("Error al cear el accioJspForm "+ param);
		}
		return o;
	}

}
