package formFaces.facade;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpServlet;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import formFaces.facade.ChainFilter;

public class ServletFilter extends HttpServlet {
	private List<AbstractFilter> filters;
	/**
	 * Al crear el ServletFilter es creen tots els filtres aix al crear la nova pipe ChainFilter
	 * se li poden passar tots creats i no cal crear-los cada vegada
	 */
	public ServletFilter() {
		super();
		filters = new ArrayList<AbstractFilter>();
		filters.add(new FacesFilter());
		// Afegir nous fiters des d'un XML
	}
	
	/**
	 * Crea una ChainFilter nova cada vegada perqu aix cada ChainFilter pot portar una iteraci 
	 * de filtres diferent per cada crida.
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response)
			throws ServletException,IOException {
			
		String nextPage = null;
		try {
			ChainFilter chf= new ChainFilter(filters);
			chf.doFilter(request, response);
			nextPage = chf.getNextPage();
		} catch (Throwable t) {
			t.printStackTrace();
		}
		RequestDispatcher rd = getServletContext().getRequestDispatcher(response.encodeURL(nextPage));
		rd.forward(request, response);
	}

	protected void doPost(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		doGet(req, resp);
	}

}
