package formFaces.tags;

import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspWriter;
import javax.servlet.ServletRequest;

import java.io.IOException;

import java.util.Iterator;
import java.util.List;


import formFaces.action.JspForm;
import formFaces.action.Classe;

public class CheckListTag extends TagSupport {
	
	private String nomLlista;
	private String campValor;
	private String campEtiqueta;
	private String campCertFals;
	private String valorCert;
	
		public int doStartTag() { 
			ServletRequest request = pageContext.getRequest();
			JspForm jf = (JspForm)request.getAttribute("JspForm");
			if (jf != null) {
				List<Classe> llista = jf.getLlista(nomLlista);
				if (llista != null) {
					try {
						if (campEtiqueta == null){campEtiqueta = campValor;}
						JspWriter out = pageContext.getOut();
						if (!llista.isEmpty()){
							for (Iterator<Classe> it=llista.iterator(); it.hasNext();){
								Classe cl = it.next();
								String valor = cl.getValor(campCertFals);
								if (valorCert != null && valor != null && valorCert.equalsIgnoreCase(valor)){
									out.print("<input type=\"checkbox\" name=\""+cl.getValor(campValor)+"\" checked>"+cl.getValor(campEtiqueta));
								} else {
									out.print("<input type=\"checkbox\" name=\""+cl.getValor(campValor)+"\">"+cl.getValor(campEtiqueta));
								}
							}
						}
					} catch(IOException ioe) {
						System.out.println("Error construint RadioListTag "+nomLlista+": " + ioe);
					}
					return(EVAL_BODY_INCLUDE);
				} else {
					System.out.println("Error construint RadioListTag Llista "+nomLlista+" no existeix a request");
					return(SKIP_BODY);
				}
			} else {
				System.out.println("Error construint RadioListTag JspForm no existeix a request");
				return(SKIP_BODY);
			}
		}
		
		public void setNomLlista(String nom) {
			this.nomLlista = nom;
		}		

		public void setCampValor(String camp){
			this.campValor = camp;
		}

		public void setCampEtiqueta(String camp){
			this.campEtiqueta = camp;
		}

		public void setCampCertFals(String camp){
			this.campCertFals = camp;
		}

		public void setValorCert(String valor){
			this.valorCert = valor;
		}

		public int doEndTag() {
			return(EVAL_PAGE); // Continue with rest of JSP page
		}
		
}
