package formFaces.tags;

import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspWriter;
import javax.servlet.ServletRequest;

import java.io.IOException;

import java.util.Iterator;
import java.util.List;


import formFaces.action.JspForm;
import formFaces.action.Classe;

public class SelectListTag extends TagSupport {
	
	private String nomLlista;
	private String nomSelect;
	private String campValor;
	private String campEtiqueta; 
	private String valorPerDefecte;
	
		public int doStartTag() {
			ServletRequest request = pageContext.getRequest();
			JspForm jf = (JspForm)request.getAttribute("JspForm");
			if (jf != null) {
				List<Classe> llista = jf.getLlista(nomLlista);
				if (llista != null) {
					try {
						if (campEtiqueta == null){campEtiqueta = campValor;}
						JspWriter out = pageContext.getOut();
						out.print("<select name=\""+nomSelect+"\">");
						if (!llista.isEmpty()){
							for (Iterator<Classe> it=llista.iterator(); it.hasNext();){
								Classe cl = it.next();
								if (valorPerDefecte != null && cl.getValor(campValor).equalsIgnoreCase(valorPerDefecte)){
									out.print("<option value=\""+cl.getValor(campValor)+"\" selected>"+cl.getValor(campEtiqueta)+"</option>");
								} else {
									out.print("<option value=\""+cl.getValor(campValor)+"\">"+cl.getValor(campEtiqueta)+"</option>");
								}
							}
						}
						out.print("</select>");
					} catch(IOException ioe) {
						System.out.println("Error construint SelectListTag "+nomLlista+": " + ioe);
					}
					return(EVAL_BODY_INCLUDE);
				} else {
					System.out.println("Error construint SelectListTag Llista "+nomLlista+" no existeix a request");
					return(SKIP_BODY);
				}
			} else {
				System.out.println("Error construint SelectListTag JspForm no existeix a request");
				return(SKIP_BODY);
			}
		}
		
		public void setNomLlista(String nom) {
			this.nomLlista = nom;
		}		

		public void setNomSelect(String nom) {
			this.nomSelect = nom;
		}		

		public void setCampValor(String camp){
			this.campValor = camp;
		}

		public void setCampEtiqueta(String camp){
			this.campEtiqueta = camp;
		}

		public void setValorPerDefecte(String valor){
			this.valorPerDefecte = valor;
		}

		public int doEndTag() {
			return(EVAL_PAGE); // Continue with rest of JSP page
		}
		
}
